/* Set the event handlers */
System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = settingsClosed;
System.Gadget.onDock = resizeGadget;
System.Gadget.onUndock = resizeGadget;

/* Refresh feed when Settings dialog is closed */
function settingsClosed(event)
{
	if (event.closeAction == event.Action.commit) 
	{
		loadTheme();
		currentAccount = 0;
		getEmails();
	}
}

/* Rezise gadget when docked/undocked */
function resizeGadget() 
{
	var themeName = System.Gadget.Settings.read('theme');
	numItems = System.Gadget.Settings.read('numItems');
	
	if (numItems == "")
	{
		numItems = 4;
	}
	if (themeName == "")
	{
		themeName = "default";
	}

	switch(numItems)
	{
		case 4: 
			document.body.style.height = '209px'; 
			message.style.height = '142px';
			break;
		case 6: 
			document.body.style.height = '278px'; 
			message.style.height = '200px';
			break;
		case 8: 
			document.body.style.height = '348px'; 
			message.style.height = '280px';
			break;
	}
	
	for (var i=0; i<numItems; i++)
	{
		document.getElementById(i+'').style.display = 'block';
	}
	for (var i=numItems; i<8; i++)
	{
		document.getElementById(i+'').style.display = 'none';
	}
	
	if (System.Gadget.docked == true)
	{
		try {
			document.body.style.background = "url('../themes/" + themeName + "/background" + numItems + ".png') no-repeat";
		}
		catch(e) {}
		for (var i=0; i<numItems; i++)
		{
			document.getElementById(i+'').className = "emailItemDocked";
		}
		message.style.width = '120px';
		navigation.style.marginLeft = '8px';
		titleLink.style.width = '72px';
		document.body.style.width = '132px';
	}
	else
	{
		try {
			document.body.style.background = "url('../themes/" + themeName + "/background-large" + numItems + ".png') no-repeat";
		}
		catch(e) {}
		for (var i=0; i<numItems; i++)
		{
			document.getElementById(i+'').className = "emailItemUndocked";
		}
		message.style.width = '355px'; 
		navigation.style.marginLeft = '127px';
		titleLink.style.width = '308px';
		document.body.style.width = '368px';
	}
}

/* Create a new RSS item object */
function RSS2Item(itemxml)
{
	this.title;
	this.link;
	this.description;
	this.pubDate;

	var properties = new Array("title", "link", "description", "pubDate");
	var tmpElement = null;
	for (var i=0; i<properties.length; i++)
	{
		tmpElement = itemxml.getElementsByTagName(properties[i])[0];
		if ( tmpElement != null )
			if ( tmpElement.childNodes != null )
				if ( tmpElement.childNodes[0] != null )
					if ( tmpElement.childNodes[0].nodeValue != null )
						eval("this."+properties[i]+"=tmpElement.childNodes[0].nodeValue");
	}
}

/* Create a new RSS channel object */
function RSS2Channel(rssxml)
{
	this.items = new Array();
	var itemElements = rssxml.getElementsByTagName("item");
	for (var i=0; i<itemElements.length; i++)
	{
		Item = new RSS2Item(itemElements[i]);
		this.items.push(Item);
	}
}

/* Download (request) the feed from the URL */
function getEmails()
{
	clear();
	var URL = System.Gadget.Settings.read("accountURL"+currentAccount);
	if (URL == "") 
	{
		titleLink.innerHTML = "DWmail";
		showMessage("No accounts have<br />been added yet");
		return true;
	}
	var themeName = System.Gadget.Settings.read('theme');
	if (themeName == "")
	{
		themeName = "default";
	}

	document.getElementById('message').style.backgroundImage = "url('themes/" + themeName + "/checking.png')";
	showMessage("Checking ...");
	currentPosition = 0;
	
 	var xmlDocument = new ActiveXObject('Microsoft.XMLDOM');
	xmlDocument.onreadystatechange = function () {
		if (xmlDocument.readyState == 4) {
			if (xmlDocument.getElementsByTagName("item") != null)
			{
				
				emails = new RSS2Channel(xmlDocument);
			}
			showEmails(emails);
		}
	};
	xmlDocument.load(URL);
	
	var refreshTime = System.Gadget.Settings.read('refresh');
	if (refreshTime > 0)
	{
		setTimeout("getEmails();", refreshTime);
	}

	var isAutoScroll = System.Gadget.Settings.read("autoScroll");
	if (isAutoScroll == 1)
	{
		setInterval("autoScroll();", 30000);
	}
	return;
}

/* Display the current 4 items in the news */
function showEmails(emails)
{
	var name = System.Gadget.Settings.read("accountName"+currentAccount);
	
	if (name != "")
	{
		titleLink.innerHTML = name;
	}
	else
	{
		titleLink.innerHTML = 'DWmail';
	}
	
	for (var i=currentPosition; (i<currentPosition+numItems) && (i<emails.items.length); i++) 
	{
		item_html = '<a ';
		item_html += (emails.items[i].link == null) ? "" : 'href="javascript:void(0)" onclick="flyoutIndex = ' + i + '; showFlyout()">';
		item_html += (emails.items[i].title == null ) ? "(no subject)</a>" : emails.items[i].title + "</a>";
		item_html += (emails.items[i].description == null) ? "" : "<br>" + getFirstLine(decodeHTML(emails.items[i].description));
		document.getElementById( (i-currentPosition) + '' ).innerHTML = item_html;
	}
	
	var posText = (currentPosition + 1) + '-' + ((currentPosition + numItems)>emails.items.length?emails.items.length:(currentPosition + numItems)) + '/' + emails.items.length;
	position.innerHTML = posText;

	System.Gadget.Settings.write("currentAccount", currentAccount);
	showMessage("");
	return true;
}

/* Display a message to the user */
function showMessage(msg)
{
	message.style.visibility = "visible";
	messageText.innerHTML = msg;
	if (msg == "")
	{
		message.style.visibility = "hidden";
	}
}

/* Loads the current theme or the default one */
function loadTheme()
{
	var themeName = System.Gadget.Settings.read('theme');
	if (themeName == "")
	{
		themeName = "default";
	}
	document.styleSheets(1).href = 'themes/' + themeName + '/style.css';
	resizeGadget();	
}

/* Show the flyout when mouse is over an item */
function showFlyout()
{
	if (flyoutIndex >= emails.items.length)
	{
		System.Gadget.Flyout.show = false;
		return true;
	}
	System.Gadget.Flyout.file = "flyout.html";
	System.Gadget.Flyout.show = true;
}

/* Clear the contents of the gadget */
function clear()
{
	for (var i=0; i<8; i++)
	{
		document.getElementById(i+'').innerHTML = '';
	}
}

/* Displays the next feed when clicking the top right arrow */
function getNextAccount()
{
	var numAccounts = System.Gadget.Settings.read("numAccounts");
	if (numAccounts == "" || numAccounts < 2 )
	{
		return true;
	}
	currentAccount = (numAccounts+1) % numAccounts;
	getEmails();	
}

/* Displays the previous feed when clicking the top left arrow */
function getPreviousAccount()
{
	var numAccounts = System.Gadget.Settings.read("numAccounts");
	if (numAccounts == "" || numAccounts < 2)
	{
		return true;
	}
	currentAccount--;
	if (currentAccount < 0)
	{
		currentAccount = numAccounts-1;
	}
	getEmails();	
}

/* Converts &lt; and &gt; into < and > */
function decodeHTML(text)
{
	var ctom = /&lt;([^&]*)&gt;/g;
	return text.replace(ctom,"<$1>");
}

function getFirstLine(text)
{
	var lines;
	lines = text.split("\n");
	if (lines.length >= 1)
	{
		return lines[0];
	}
	else
	{
		return false;
	}
}

/* Scroll one page up */
function previousPage()
{
	currentPosition = (currentPosition - numItems >= 0) ? currentPosition - numItems : ((emails.items.length - emails.items.length%numItems)); 
	if (currentPosition >= emails.items.length)
	{
		currentPosition -= numItems;
	}
	clear();
	showEmails(emails);
}

/* Scroll one page down */
function nextPage()
{
	currentPosition = (currentPosition + numItems) >= emails.items.length ? 0 : (currentPosition + numItems); 
	clear();
	showEmails(emails);
}

/* Navigates through the feeds automatically */
function autoScroll()
{
	nextPage();
	if (currentPosition == 0)
	{
		getNextAccount();
	}
}

/* Current position in the feed */
var currentPosition = 0;

/* The index of the item that must be displayed in the flyout */
var flyoutIndex = 0;

/* The news items */
var emails;

/* The index of the current feed in the list */
var currentAccount = ((System.Gadget.Settings.read("currentAccount") == "") ? 0 : System.Gadget.Settings.read("currentAccount"));

/* Number of items to display on a page */
var numItems = ((System.Gadget.Settings.read("numItems") == "") ? 4 : System.Gadget.Settings.read("numItems"));

var autoScrollIntervalId = 0;