/* Set the event handlers */
System.Gadget.onSettingsClosing = settingsClosing;

/* Saves the settings when settings dialog is closed */
function settingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
        System.Gadget.Settings.write("refresh", notRefresh.options[notRefresh.selectedIndex].value);
        System.Gadget.Settings.write("theme", notTheme.options[notTheme.selectedIndex].value);
	System.Gadget.Settings.write("numItems", numItems.options[numItems.selectedIndex].value);
	System.Gadget.Settings.write("autoScroll", ((autoScrollCheckBox.checked == true) ? 1 : 0 ));
        event.cancel = false;
    }
}

/* Loads the existing settings when the Settings dialog is shown */
function loadSettings() 
{
	var refresh = System.Gadget.Settings.read("refresh");
	var theme = System.Gadget.Settings.read("theme");

	switch (refresh) {
		case 60000:
			notRefresh[0].selected = "1";
			break;
		case 300000:
			notRefresh[1].selected = "1";
			break;
		case 900000:
			notRefresh[2].selected = "1";
			break;
		case 1800000:
			notRefresh[3].selected = "1";
			break;
		case 3600000:
			notRefresh[4].selected = "1";
			break;
		default:
			notRefresh[5].selected = "1";
	}	
	
	for (var i=0; i<2; i++)
	{
		if (notTheme[i].value == theme)
		{
			notTheme[i].selected = "1";
		}
	}
	updatePreview();

	buildAccountList();
	var current = System.Gadget.Settings.read("currentAccount");
	if ( current == "" ) current = 0;
	accounts.options[current].selected = "1";
	
	var isAutoScroll = System.Gadget.Settings.read("autoScroll");
	autoScrollCheckBox.checked = (isAutoScroll == 1);
	var items = System.Gadget.Settings.read("numItems");
	if (items == "")
	{
		items = 4;
	}
	numItems.options[items/2-2].selected = "1";
}

/* Shows a specified section of the settings */
function showSection(section)
{
	accountsSec.style.display = 'none';
	aboutSec.style.display = 'none';
	optionsSec.style.display = 'none';
	section.style.display = 'block';
}


/* Updates the preview image when theme is switched */
function updatePreview()
{
	previewImage.src = "/themes/" + notTheme.options[notTheme.selectedIndex].value + "/preview.png";
}

/* Builds the accounts combo */
function buildAccountList()
{
	var n;
	var aux = System.Gadget.Settings.read("numAccounts");
	if (aux == "")
	{
		n = 0;
	}
	else
	{
		n = aux;
	}
	
	for (var i=0; i<accounts.options.length; i++)
	{
		accounts.options[i] = null;
	}
	
	for (var i=0; i<n; i++)
	{
		var text = System.Gadget.Settings.read("accountName"+i);
		accounts.options[i] = new Option(text,i+'');
	}
}

/* Add a new account to the settings */
function addNewAccount(name, url)
{
	if (url == "")
	{
		if (accountURL.value.replace(/^\s+|\s+$/, '') == "") 
		{
			errorMessage.innerHTML = "URL is empty.";
			return true;
		}
		if (accountName.value.replace(/^\s+|\s+$/, '') == "")
		{
			errorMessage.innerHTML = "Name is empty.";
			return true;
		}
		url = accountURL.value;
		name = accountName.value;
	}
	
	var n;
	var aux = System.Gadget.Settings.read("numAccounts");
	if (aux == "")
	{
		n = 0;
	}
	else
	{
		n = aux;
	}

	System.Gadget.Settings.write("accountName"+n, name);	
	System.Gadget.Settings.write("accountURL"+n, url);	

	n++;
	System.Gadget.Settings.write("numAccounts",n);
	
	accountName.value = "";
	accountURL.value = "";
	errorMessage.innerHTML = "";
	
	buildAccountList();
	accounts.options[accounts.options.length-1].selected = "1";
}

/* Deletes an existing account from the settings */
function deleteExistingAccount()
{
	var n;
	var aux = System.Gadget.Settings.read("numAccounts");
	if (aux == "")
	{
		n = 0;
	}
	else
	{
		n = aux;
	}
	
	for (var i=accounts.selectedIndex; i<n; i++)	
	{
		var URL = System.Gadget.Settings.read("accountURL"+(i+1));
		var name = System.Gadget.Settings.read("accountName"+(i+1));
		System.Gadget.Settings.write("accountURL"+i, URL);
		System.Gadget.Settings.write("accountName"+i, name);
	}
	
	if (n > 0)
	{
		n--;
	}
	else
	{
		n = 0;
	}

	System.Gadget.Settings.write("numAccounts",n);
	
	buildAccountList();
}